let w = 15
let h = 15
let n = (w+2) * (h+2)
let empty = -1
let dist_sep = -2
let border = -3
let wall = -4
let a = Array.make n (-1)

let l = ref 0
let l1 = ref 0
let dist = ref 0
let q = Array.make (n*2) 0

let add_some_walls () =
  for i = 0 to n-1
  do
    if (Random.int 3) = 0 then a.(i) <- wall
  done

let print_current () =
  let k = ref !l in
  Format.print_newline ();
  Format.printf "l: ";
  while q.(!k) != dist_sep do
    Format.printf "q.(%d) = %d " !k q.(!k);
    incr k
  done;
  Format.print_newline ();
  incr k;
  Format.printf"l1: ";
  while !k <= !l1 do
    Format.printf "q.(%d) = %d " !k q.(!k);
    incr k
  done;
  Format.print_newline ()

let dostuff () =
 for i=0 to w+1 do a.(i) <- border done;
 for i=n-(w+2) to n-1 do a.(i) <- border done;
 for i=1 to h do a.(i*(w+2)) <- border done;
 for i=1 to h do a.(i*(w+2)+w+1) <- border done;

 q.(0) <- w+3;
 q.(1) <- dist_sep;
 l := 0;
 l1 := 1;
 while !l != !l1 do
   let i = q.(!l) in
     (* print_current (); *)
     incr l;
     if (i != dist_sep)
     then if a.(i) = empty
       then
         begin
           a.(i) <- !dist;
	   if a.(i-1) = empty then (incr l1; q.(!l1) <- i-1);
	   if a.(i+1) = empty then (incr l1; q.(!l1) <- i+1;
	      (* Format.printf "i+1:%d a.(i+1):%d" (i+1) a.(i+1);
               Format.print_newline () *));
	   if a.(i-(w+2)) = empty then (incr l1; q.(!l1) <- i-(w+2));
	   if a.(i+(w+2)) = empty then (incr l1; q.(!l1) <- i+(w+2))
         end
       else ()
     else
       begin
         incr dist;
         (* incr l; *)
	 incr l1;
         q.(!l1) <- dist_sep
       end
 done

exception Origin_not_reachable

let mark_back dest =
  let r = ref dest in
  while a.(!r) != 0
  do
    let i = !r in
    begin
      if a.(i-1) + 1 = a.(i) then r := i-1 else
      if a.(i+1) + 1 = a.(i) then r := i+1 else
      if a.(i-(w+2)) + 1 = a.(i) then r := i-(w+2) else
      if a.(i+(w+2)) + 1 = a.(i) then r := i+(w+2)
      else raise Origin_not_reachable
    end;
    a.(i) <- 0
  done

let print_arr () =
 let pp n = match n with
            | 0 -> Format.printf "%3s" "*"
	    | n when n=empty -> Format.printf "%3s" "."
	    | n when n=border -> Format.printf "%3s" "+"
	    | n when n=wall -> Format.printf "%3s" "#"
	    | _ -> Format.printf "%3d" n in
 for j=0 to h+1 do
  for i=0 to w+1 do pp a.(i + (w+2)*j) done;
  Format.print_newline ()
 done


let _ = add_some_walls ();
        dostuff ();
        print_arr ();
	mark_back (n-(w+4));
	Format.printf "Back path:";
	Format.print_newline ();
	print_arr ()
