(* $Id: distance_rects.mli,v 1.1 2002/09/02 13:55:26 richard Exp $ *)

(* the directions (N,E,S,W) from which there exists a shortest path
   from the current position to dest *)

type dir = {dn:bool; de:bool; ds:bool; dw:bool}

val get_dirs : Types.coords -> (dir*int) option          (* None if no path; Some dirs,length otherwise *)
val get_path : Types.coords -> ((int*int) list*int) option (* just follow this path, baby *)
