(* $Id: world.mli,v 1.2 2002/09/01 07:28:16 berdine Exp $ *)

open Types

type map = {width: int; height: int; tiles: string array}
(* increasing string indices moves east
   increasing array indices moves north *)
val map_rep : map ref

type player = {id: robot_id; starting_money: int; capacity: int}
val player_rep : player ref

val input_map : in_channel -> unit
val input_player_config : in_channel -> unit
