(* $Id: global_decision.mli,v 1.3 2002/09/01 23:56:01 berdine Exp $ *)

type direction = Local_decision.direction
type priority = Local_decision.priority

val default_prio : priority

type command = Local_decision.command =
  | CMove of priority * direction
  | CPick of priority * Package.IdSet.t
  | CDrop of priority * Package.IdSet.t

val init : unit -> unit
(* to be called after the map has been input *)

val output_command : out_channel -> unit
(* the client will call this *)
