(* $Id: test_package.ml,v 1.1 2002/09/02 10:23:09 richard Exp $ *)

open Package

let cross_packs =
	[ ((11,11), [
		   (0, {d=(4,11); w=11});
		   (1, {d=(4,11); w=11});
		   (2, {d=(4,11); w=11});
		   (3, {d=(4,11); w=11});
		   (4, {d=(4,11); w=11});
		   (5, {d=(4,11); w=11});
		   (6, {d=(4,11); w=11});
		   (7, {d=(4,11); w=11});
		   (8, {d=(4,11); w=11});
		   (9, {d=(4,11); w=11});
	   
		   (10, {d=(11,4); w=11});
		   (11, {d=(11,4); w=11});
		   (12, {d=(11,4); w=11});
		   (13, {d=(11,4); w=11});
		   (14, {d=(11,4); w=11});
		   (15, {d=(11,4); w=11});
		   (16, {d=(11,4); w=11});
		   (17, {d=(11,4); w=11});
		   (18, {d=(11,4); w=11});
		   (19, {d=(11,4); w=11});
		   
		   (20, {d=(19,11); w=11});
		   (21, {d=(19,11); w=11});
		   (22, {d=(19,11); w=11});
		   (23, {d=(19,11); w=11});
		   (24, {d=(19,11); w=11});
		   (25, {d=(19,11); w=11});
		   (26, {d=(19,11); w=11});
		   (27, {d=(19,11); w=11});
		   (28, {d=(19,11); w=11});
		   (29, {d=(19,11); w=11});
		   
		   (30, {d=(11,19); w=11});
		   (31, {d=(11,19); w=11});
		   (32, {d=(11,19); w=11});
		   (33, {d=(11,19); w=11});
		   (34, {d=(11,19); w=11});
		   (35, {d=(11,19); w=11});
		   (36, {d=(11,19); w=11});
		   (37, {d=(11,19); w=11});
		   (38, {d=(11,19); w=11});
		   {pkgid=39; d=(11,19); w=11}])]

let maze_packs = [
	  ((59,2), [
		   (0, {d=(2,45); w=10});
		   (1, {d=(2,45); w=10});
		   {pkgid=2; d=(2,45); w=10}]);
	
	  ((59,3), [
		   (3, {d=(2,45); w=10});
		   (4, {d=(2,45); w=10});
		   {pkgid=10; d=(75,45); w=10}]);
	  
	  ((60,2), [
		   (11, {d=(75,45); w=10});
		   (12, {d=(75,45); w=10});
		   {pkgid=13; d=(75,45); w=10}]);
	  
	  ((60,3), [
		   (14, {d=(75,45); w=10});
		   {pkgid=5; d=(2,45); w=10}]);
	  
	  ((74,2), [
		   (6, {d=(2,45); w=10});
		   (7, {d=(2,45); w=10});
		   {pkgid=8; d=(2,45); w=10}]);
	  
	  ((74,3), [
		   (9, {d=(2,45); w=10});
		   (15, {d=(75,45); w=10});
		   (16, {d=(75,45); w=10});
		   {pkgid=17; d=(75,45); w=10}]);
	  
	  ((75,2), [
		   {pkgid=18; d=(75,45); w=10}]);
	  
	  ((75,3), [
		   {pkgid=19; d=(75,45); w=10}])]

let lakes_packs =
	[ ((59,22), [
		   (1, {d=(2,2); w=11});
		   (2, {d=(2,2); w=12});
		   (3, {d=(2,2); w=13});
		   (4, {d=(2,2); w=14});
		   (5, {d=(2,2); w=15});
		   (6, {d=(2,2); w=16});
		   (7, {d=(2,2); w=17});
		   (8, {d=(2,2); w=18});
		   (9, {d=(2,2); w=19});
		   (10, {d=(2,2); w=20});
		   (11, {d=(2,2); w=21});
		   (12, {d=(2,2); w=22});
		   (13, {d=(2,2); w=23});
		   (14, {d=(2,2); w=24});
		   (15, {d=(2,2); w=25});
		   (16, {d=(2,2); w=26});
		   (17, {d=(2,2); w=27});
		   (18, {d=(2,2); w=28});
		   (19, {d=(2,2); w=29});
		   {pkgid=20; d=(2,2); w=30}]);
	  
	  ((17,16), [
		   (21, {d=(2,2); w=11});
		   (22, {d=(2,2); w=12});
		   (23, {d=(2,2); w=13});
		   (24, {d=(2,2); w=14});
		   (25, {d=(2,2); w=15});
		   (26, {d=(2,2); w=16});
		   (27, {d=(2,2); w=17});
		   (28, {d=(2,2); w=18});
		   (29, {d=(2,2); w=19});
		   (30, {d=(2,2); w=20});
		   (31, {d=(2,2); w=21});
		   (32, {d=(2,2); w=22});
		   (33, {d=(2,2); w=23});
		   (34, {d=(2,2); w=24});
		   (35, {d=(2,2); w=25});
		   (36, {d=(2,2); w=26});
		   (37, {d=(2,2); w=27});
		   (38, {d=(2,2); w=28});
		   (39, {d=(2,2); w=29});
		   {pkgid=40; d=(2,2); w=30}])]
